<?php
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

class AntiAspi_maintain extends PluginMaintain
{
  private $default_conf = array(
    'diff' => '20 pages in 00:00:10',
    'same' => '15 pages in 00:00:30',
    'banned during' => '23:59:59',
    'only guest' => true,
    'only picture' => false,
    'allowed ip' => array('123.123.123.123','122.122.122.122'),
    );

  function install($plugin_version, &$errors=array())
  {
    global $prefixeTable, $conf;

    // add config parameter
    if (empty($conf['antiaspi']))
    {
      conf_update_param('antiaspi', $this->default_conf, true);
    }
    else
    {
      $old_conf = safe_unserialize($conf['antiaspi']);

      foreach (array_keys($this->default_conf) as $conf_key)
      {
        if (!isset($old_conf[$conf_key]))
        {
          $old_conf[$conf_key] = $this->default_conf[$conf_key];
        }
      }

      conf_update_param('antiaspi', $old_conf, true);
    }

    // table antiaspi_ip_ban to store list of banned IP addresses
    $result = pwg_query('SHOW TABLES LIKE "'.$prefixeTable.'antiaspi_ip_ban";');
    if (!pwg_db_num_rows($result))
    {
      $query = "
CREATE TABLE " . $prefixeTable . "antiaspi_ip_ban (
  id int(11) NOT NULL auto_increment,
  ip char(50) NOT NULL default '',
  date char(20) NOT NULL default '',
  PRIMARY KEY (id),
  KEY ip (ip)
) ENGINE=MyISAM DEFAULT CHARSET=utf8
;";
      pwg_query($query);
    }

    // table antiaspi_log to store a specific "short-term" log
    // (ENGINE=MEMORY, specific)
    $result = pwg_query('SHOW TABLES LIKE "'.$prefixeTable.'antiaspi_log";');
    if (!pwg_db_num_rows($result))
    {
      $query = "
CREATE TABLE " . $prefixeTable . "antiaspi_log (
  IP varchar(15) NOT NULL default '',
  occured_on datetime NOT NULL,
  image_id mediumint(8) default NULL,
  category_id smallint(5) default NULL
) ENGINE=MEMORY DEFAULT CHARSET=utf8
;";
      pwg_query($query);
    }
  }

  function update($old_version, $new_version, &$errors=array())
  {
    $this->install($new_version, $errors);
  }

  function uninstall()
  {
    global $prefixeTable;

    pwg_query('DROP TABLE '.$prefixeTable.'antiaspi_ip_ban;');
    pwg_query('DROP TABLE '.$prefixeTable.'antiaspi_log;');

    // delete configuration
    pwg_query('DELETE FROM `'. CONFIG_TABLE .'` WHERE param IN ("antiaspi");');
  }
}
